<?











function &resolveProperty( $rProperty, &$start )
{
 $result =& resolvePropertyObject($rProperty, $start);
 if ( is_a($result["obj"], "nodeexception") )
 return $result["obj"];
 return _resolve_($result["prop"], $result["obj"]);
}









function &resolvePropertyObject( $rProperty, &$start )
{
 global $DEBUG;
 $in = FALSE;
 if ( strlen($rProperty) == 0 )
 {
 return array(
 "obj"=>&$start,
 "prop"=>"" 
 );
 }
 $tree = explode( ".", strtolower($rProperty) );
 $property = $tree[count($tree)-1];
 $tree = array_slice($tree, 0, -1);
 $loop = &$start;
 foreach ( $tree as $treeEle )
 {
 if ( $treeEle )
 {
 $in = TRUE;
 unset( $res );
 $loop =&_resolve_($treeEle, $loop);
 if ( is_a( $loop, "nodeexception" ) )
 break; 
 }
 }
 return array( "obj"=>&$loop, "prop"=>$property);
}

function &_resolve_( $property, &$loop )
{
 if ( strlen ( $property ) == 0 ) return $loop;
 
 $loopClass = get_class($loop);
 if ( is_object($loop) && method_exists($loop, "getproperty")) {
 unset( $tmp );
 $tmp = &$loop->getProperty( $property );
 unset( $loop );
 $loop =& $tmp;
 } else {
 $loop = new NodeException("resolveProperty: Object ($loopClass) is not an object or does not implement getProperty.");
 }
 
 if ( is_a( $loop, "nodeexception" ) )
 {
 if ($DEBUG["echo"]) {
 echo "<b>Warning:</b> Exception while fetching property ($property) from $loopClass:<br>";
 echo "<b>Exception is:</b>".$loop->toString()."<br>";
 }
 }
 return $loop;
}

?>
