<?




function datestring2ts($date, $lower = 0, $checkError = false) {
 global $TIME, $REGEX, $REG;

 $ret = 0;

 if ($date) {

 if (!ereg($REGEX[23],$date,$regs)) return ($checkError)?$REG[23]["desc"]:0;
 if ($regs[1] == "") $regs[1] = date("d",$TIME);
 if ($regs[3] == "") $regs[3] = date("m",$TIME);
 if ($regs[5] == "") $regs[5] = date("Y",$TIME);
 if ($regs[5] < 100) $regs[5] = floor(date("Y",$TIME)/100)*100 + $regs[5];

 $ret = mktime(0,0,0,$regs[3],$regs[1],$regs[5]);

 } else $ret = max($TIME,$lower);

 return $ret;
}


function date2ts($date, $lower = 0, $checkError = false) {
 return datestring2ts($date,$lower);
}

function time2ts($time, $lower = 0, $checkError = false) {
 global $TIME, $REGEX, $REG;

 $ret = 0;

 if ($time) {

 if (!ereg($REGEX[21],$time,$regs)) return ($checkError)?$REG[21]["desc"]:0;
 if ($regs[1] == "") $regs[1] = date("H",$TIME);
 if ($regs[3] == "") $regs[3] = 0;

 $ret = mktime($regs[1], $regs[3], 0, date("m",$TIME), date("d",$TIME), date("Y",$TIME));
 
 } else $ret = max($TIME, $lower);

 return $ret;
}


function merge_date_time($date, $time) {

 return mktime(date("H",$time), date("i", $time), date("s",$time), date("m",$date), date("d", $date), date("Y", $date));

}

function validateDate($date) {
 global $REG;
 return (ereg($REG[23]["exp"], $date))?true:$REG[23]["desc"];
}

function validateTime($time) {
 global $REG;
 return (ereg($REG[21]["exp"], $date))?true:$REG[21]["desc"];
}

?>
