<?php
$mainGUI = &GUIFactory::setMainGUI( "main" );
$mainGUI->includeJS("jquery");
$mainGUI->includeJS("jquery.tipsy");
$mainGUI->includeJS("jstorage-0.1.5.min");

node_include("htmlform3");
node_include("load_menu");

mysession_var_reg("CR_ID");
mysession_var_reg("cr_node_id");
load_menu(15214, T_CONTENTREPOSITORY, $CR_ID);

$form = new HtmlForm3("cr_node_conflict");
if ($form->isNew()) {
 
 $form->setHeader(i18n("channels_already_assigned"));
 
 $form->addComponent("description", new LabelComponent(null, i18n("channels_already_assigned_detail"), true));
 
 global $cr_node_id;
 $select = "n.id, f.name as nodename, c.name as crname";
 $from ="node n left join folder f on f.node_id = n.id left join contentrepository c on c.id = n.contentrepository_id";
 $where ="f.channelset_id in (select f.channelset_id from node n left join folder f on f.node_id = n.id where n.id = ". sqlslashes($cr_node_id) .") and n.contentrepository_id is not NULL and n.contentrepository_id != 0 and f.is_master = 0";
 
 $ds = new SQLDatasource( "crs",$select , $from, $where);
 $ds->setSearchable(false);
 $ds->setDBHandle($DB);
 $ds->addColumn("nodename", i18n("Node"), true, false );
 $ds->addColumn("crname", i18n("Content.Repository"), true, false);
 
 $itemlist = new ItemList3("itemlist", $ds);
 
 $list = new ItemListComponent(NULL, $itemlist);
 $form->addComponent("emptyobjtagslist", $list);
 
 $form->addComponent("question", new LabelComponent(null, i18n("assign_node_anyway"), true));
 $form->addButton("cancel", new Button(i18n("cancel"), true, true), new SimpleFormAction("assign_node_cancel"), true);
 $form->addButton("assign_node", new Button(i18n("assign_node"), true, true), new SimpleFormAction("assign_node_continue"), true);
}





function assign_node_cancel($form) {
 global $REDO;
 $REDO = 15216;
 return;
}





function assign_node_continue($form) {
 global $REDO, $CR_ID, $cr_node_id;
 cmd_assign_node($CR_ID, $cr_node_id);
 $REDO = 15216;
 return;
}

?>